﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

public class DragScript : MonoBehaviour, IBeginDragHandler, IDragHandler, IEndDragHandler
{

    public GameObject timelinePrefab;
    GameObject timelineElement;
    GameObject timelineArea;
    TimelineScript timelineScript;
    int newSibIndex;
    int placeHolderSibIndex;

    public bool inBounds = false;

    public void OnBeginDrag(PointerEventData eventData)
    {
        timelineScript = FindObjectOfType<TimelineScript>();
        timelineArea = timelineScript.gameObject;
        timelineElement = Instantiate(timelinePrefab) as GameObject;
        GameObject canvas = FindObjectOfType<Canvas>().gameObject;
        timelineElement.transform.SetParent(canvas.transform);
        placeHolderSibIndex = timelineScript.corroborations.Count;

        //set info for timelineElement
        Text details = timelineElement.GetComponentInChildren<Text>();
        details.text = this.GetComponentInChildren<Text>().text;

        EvidenceUI newEvScript = timelineElement.GetComponent<EvidenceUI>();
        var fields = newEvScript.GetType().GetFields();
        foreach(var field in fields)
        {
            field.SetValue(newEvScript, field.GetValue(this.GetComponent<EvidenceUI>()));
        }


    }

    public void OnDrag(PointerEventData eventData)
    {
        timelineElement.transform.position = eventData.position;

        newSibIndex = timelineScript.corroborations.Count;
        Debug.Log(newSibIndex);

        for (int i = 0; i < timelineScript.corroborations.Count; i++)
        {
            if (eventData.position.x < timelineArea.GetComponentInChildren<ScrollRect>().gameObject.transform.GetChild(0).transform.GetChild(i).transform.position.x)
            {
                newSibIndex--;
            }
        }
        Debug.Log(newSibIndex);

    }

    public void OnEndDrag(PointerEventData eventData)
    {

        Debug.Log(placeHolderSibIndex);

        if (eventData.position.x > (timelineArea.GetComponent<RectTransform>().rect.xMin + (timelineArea.GetComponent<RectTransform>().rect.width / 2)) && eventData.position.x < (timelineArea.GetComponent<RectTransform>().rect.xMax + (timelineArea.GetComponent<RectTransform>().rect.width / 2)))
        {

            if (eventData.position.y > (timelineArea.GetComponent<RectTransform>().rect.yMin + (timelineArea.GetComponent<RectTransform>().rect.height / 2)) && eventData.position.y < (timelineArea.GetComponent<RectTransform>().rect.yMax + (timelineArea.GetComponent<RectTransform>().rect.height / 2)))
                {
                if (CheckElements(timelineElement))
                {
                    timelineElement.transform.SetParent(timelineArea.GetComponentInChildren<ScrollRect>().gameObject.transform.GetChild(0));
                    timelineElement.transform.SetSiblingIndex(newSibIndex);
                    timelineScript.corroborations.Insert(newSibIndex, timelineElement);
                }
                else
                {
                    Destroy(timelineElement);
                }
            }
            else
            {
                Destroy(timelineElement);
            }
        }
        else
        {
            Destroy(timelineElement);
        }
    }

    bool CheckElements(GameObject curElement)
    {
        Text curId = curElement.GetComponentInChildren<Text>();
        for(int i = 0; i < timelineScript.corroborations.Count; i++)
        {
            Text timelineID = timelineScript.corroborations[i].GetComponentInChildren<Text>();

            if(timelineID.text == curId.text)
            {
                Debug.Log("false");
                return false;
            }
        }
        Debug.Log("true");
        return true;
    }
}
